Scriptname LichNecroActorScript extends ActiveMagicEffect  
{Abilities and FX for Lich}

import debug
import ObjectReference

Quest Property LichTrackingQuest auto

Message Property NecroLeftMagicSelectMessage auto
Message Property NecroElementalMagicMessage auto
Message Property NecroSummoningMagicMessage auto
Message Property NecroDarkMagicMessage auto
Message Property NecroUtilityMagicMessage auto
Message Property NecroDarkMagic2Message auto
Message Property NecroInfernalMagicMessage auto
Message Property NecroMindMagicMessage auto
Message Property NecroDiseaseMagicMessage auto

Faction Property LichFaction auto

Weapon Property NecroStaffOfWorms auto
Armor Property NecroLichForm auto

Race Property LichRace auto
Race Property playerRace auto

float PlayerHP
float PlayerMG
float PlayerST

Int Property HP  Auto
Int Property Magicka  Auto  
Int Property Stamina  Auto 

Spell Property NecroLichTransform auto
Spell Property NecroLichAbility auto
Spell Property NecroLichRevert auto
Spell Property NecroLichDeathGrip auto
Spell Property NecroLichBlizzard auto
Spell Property NecroLichFireStorm auto
Spell Property NecroLichLightningStorm auto
Spell Property NecroLichDarkFlare auto
Spell Property NecroLichHealing auto
Spell Property NecroLichIncinerate auto
Spell Property NecroLichThunderbolt auto
Spell Property NecroLichIcySpear auto
Spell Property NecroLichFrostArmor auto
Spell Property NecroLichRevenant auto
Spell Property NecroLichWardGreater auto
Spell Property NecroLichAbsorbMagicka auto
Spell Property NecroLichConjureBoneman auto
Spell Property NecroLichConjureMistMan auto
Spell Property NecroLichConjureWrathman auto
Spell Property NecroLichConjureFlameAtronach auto
Spell Property NecroLichConjureFrostAtronach auto
Spell Property NecroLichConjureStormAtronach auto
Spell Property NecroLichCandlelight auto
Spell Property NecroLichDetectAura auto
Spell Property NecroLichCommandUndead auto
Spell Property NecroLichShockwave auto
Spell Property NecroLichInvisibility auto
Spell Property NecroLichSoulTrap auto
Spell Property NecroCorpseExplosionSpell Auto
Spell Property NecroMarkOfTheWormKingSpell Auto
Spell Property NecroSoulCorruptionSpell Auto
Spell Property NecroWitheringAfflictionSpell Auto
Spell Property NecroSeedOfPestilenceSpell Auto
Spell Property NecroLichDrainLifeSpell Auto
Spell Property NecroInfernalFlames Auto
Spell Property NecroInfernalSurgeSpell Auto
Spell Property NecroDevourMagickaSpell Auto
Spell Property NecroLichSoulfireSpell Auto
Spell Property NecroPowerOverwhelmingSpell Auto
Spell Property NecroLichDeathShroudSpell Auto
Spell Property NecroSiphonSoulSpell Auto
Spell Property NecroLichSoulCurse Auto
Spell Property NecroMindBlastSpell Auto
Spell Property NecroPsychosisSpell Auto
Spell Property NecroMindFlaySpell Auto
Spell Property NecroLucidNightmareSpell Auto
Spell Property NecroWhispersOfMadnessSpell Auto
Spell Property NecroWormEnthrall Auto
Spell Property NecroLichDarkSacrifice Auto
Spell Property NecroDeathGrip Auto
Spell Property NecroWitheringAuraCloak Auto
Spell Property NecroLichAgonySpell Auto
Spell Property NecroLichWardSpell Auto
Spell Property NecroLichGhastlyPhantasm Auto
Spell Property NecroPlaneShiftLichFormSpell Auto
Spell Property NecroCurseOfKnightsbane Auto
Spell Property NecroCurseOfBonerot Auto

MagicEffect Property NecroRevertEffect auto

armor property DragonPriestArmor01 auto
{Glowing cape and mouth streams armor}

VisualEffect Property DragonPriestParticlesFX Auto
{Floor based stream of upward particles}

VisualEffect Property DragonPriestEyeGlowFX Auto
{eye glow fx}

VisualEffect Property FXfallingSandDragonPriestEffect Auto
{falling sand from holes fx}

Explosion Property FXDragonPriestSmallExplosion Auto
{dust and fabric explosion played on state change}

Explosion Property FXDragonPriestLargeExplosion Auto
{large dust fabric and metal bits explosion played on dying}

Activator property AshPileObject auto
{The object we use as a pile.}

float DragonPriestHealth
int doOnce = 0 ;Stops on hit from spamming
Actor selfRef ;local pointer to the curren dragon priest

EVENT OnEffectStart(Actor Target, Actor Caster)
	selfRef = caster  ;local pointer to the curren dragon priest
	;actor PlayerActor = Game.GetPlayer()

	;DragonPriestHealth = SelfRef.GetActorValuePercentage("health")
	if (selfRef.GetSleepState() == 3)
; 			Debug.Trace("DP is sleeping! 3")
	else
		;Play all of the magic fx
		DragonPriestParticlesFX.play(selfRef, -1)
		DragonPriestEyeGlowFX.play(selfRef, -1)
	endif

;	RegisterForUpdate(3)
	
	; call reg function inside if statement.  If the event isn't found in the graph, function returns a false
	if (!RegisterForAnimationEvent(selfRef, "IdleStop" ))
		;debug.notification("could not register for IdleStop")
	else
 		;debug.notification("registered for animation event")
endif

ENDEVENT

	Event OnGetUp(ObjectReference akFurniture)
; 		Debug.Trace("Dragon preist just got up from " )
		;Play all of the magic fx
		selfRef.equipitem(DragonPriestArmor01)
		DragonPriestParticlesFX.play(selfRef, -1)
		DragonPriestEyeGlowFX.play(selfRef, -1)
	endEvent

Event OnHit(ObjectReference akAggressor, Form akSource, Projectile akProjectile, bool abPowerAttack, bool abSneakAttack, bool abBashAttack, bool abHitBlocked)
		;selfRef = self ;local pointer to the curren dragon priest
		DragonPriestHealth = (selfRef as actor).GetActorValuePercentage("health")
		if (DragonPriestHealth <= 0.3) && doOnce < 1
			(selfRef as actor).placeAtMe(FXDragonPriestSmallExplosion, 1)
			DragonPriestParticlesFX.Stop((selfRef as actor))
			FXfallingSandDragonPriestEffect.play((selfRef as actor), -1)
			selfRef.PlaySubGraphAnimation( "stage2" )
			doOnce = doOnce + 1
		endIf

ENDEVENT

Event OnAnimationEventUnregistered(ObjectReference akSource, string asEventName)
 	;debug.notification(self + "OnAnimationEventUnregistered " + akSource + " " + asEventName)
endEvent

EVENT OnAnimationEvent(ObjectReference akSource, string  asEventName)

	;Debug.Notification("LICH: Animation Event! " + akSource + " " + asEventName)

    	actor PlayerActor = Game.GetPlayer()
    	
	if (asEventName == "IdleStop") && (akSource == PlayerActor)
        	SpellChange()
	endif

ENDEVENT

EVENT OnDying(Actor akKiller)
	; play all of the many dying fx and clean up the magic fx
	selfRef.placeAtMe(FXDragonPriestLargeExplosion, 1)
	selfRef.PlaySubGraphAnimation( "stage3" )
	selfRef.unequipitem(DragonPriestArmor01)
	DragonPriestEyeGlowFX.Stop(selfRef)
	;place ash pile
	utility.wait(1.0)
	selfRef.AttachAshPile(AshPileObject)
	utility.wait(2.0)
	FXfallingSandDragonPriestEffect.Stop(selfRef)
	
ENDEVENT

FUNCTION SpellChange(Int Option = 0, Int Button = 0, Bool abMenu = True)
     While abMenu
         If Button == -1
         ElseIf Option == 0
             Button = NecroLeftMagicSelectMessage.Show()
             If Button == 0
               Option = 1
             Elseif Button == 1
                Option = 2
             Elseif Button == 2
                Option = 3
             Elseif Button == 3
                Option = 4  
             Elseif Button == 4
                Option = 5
			 Elseif Button == 5
			    Option = 6
			 Elseif Button == 6
			    Option = 7
			 Elseif Button == 7
			    Option = 8
			 Elseif Button == 8
			    abMenu = False
             EndIf   
         ElseIf Option == 1
             Button = NecroElementalMagicMessage.Show()
             If Button == 0                                                                                ;Incinerate
                 selfRef.equipspell(NecroLichIncinerate, 1)
                 abMenu = False 
                 Debug.Notification("Incinerate Selected")
             ElseIf Button == 1                                                                          ;Thunderbolt
                 selfRef.equipspell(NecroLichThunderbolt, 1)
                 abMenu = False 
                 Debug.Notification("Thunderbolt Selected")
             ElseIf Button == 2                                                                          ;Icy Spear
                 selfRef.equipspell(NecroLichIcyspear, 1)
                 abMenu = False 
                 Debug.Notification("Icy Spear Selected")
             ElseIf Button == 3                                                                          ;Firestorm
                  selfRef.equipspell(NecroLichFirestorm, 1)
                  abMenu = False 
                 Debug.Notification("Firestorm Selected")
             ElseIf Button == 4                                                                          ;Lightning Storm
                  selfRef.equipspell(NecroLichLightningStorm, 1)
                  abMenu = False 
                 Debug.Notification("Lightning Storm Selected")
             ElseIf Button == 5                                                                          ;Blizzard
                  selfRef.equipspell(NecroLichBlizzard, 1)
                  abMenu = False 
                 Debug.Notification("Blizzard Selected")  
             ElseIf Button == 6                                                                          
                 Option = 0
             Endif
         ElseIf Option == 2        
             Button = NecroSummoningMagicMessage.Show()
             If Button == 0                                                                                           ;Conjure Flame Atronach
                  selfRef.equipspell(NecroLichConjureFlameAtronach, 1)
                  abMenu = False 
                 Debug.Notification("Conjure Flame Atronach Selected")
             ElseIf Button == 1                                                                                     ;Conjure Frost Atronach
                  selfRef.equipspell(NecroLichConjureFrostAtronach, 1)
                  abMenu = False 
                 Debug.Notification("Conjure Frost Atronach Selected")
             ElseIf Button == 2                                                                                     ;Conjure Storm Atronach
                  selfRef.equipspell(NecroLichConjureStormAtronach, 1)
                  abMenu = False 
                 Debug.Notification("Conjure Storm Atronach Selected")
             ElseIf Button == 3                                                                                     ;Conjure Boneman
                  selfRef.equipspell(NecroLichConjureBoneman, 1)
                   abMenu = False 
                 Debug.Notification("Conjure Boneman Selected")
             ElseIf Button == 4                                                                                     ;Conjure Mistman
                  selfRef.equipspell(NecroLichConjureMistman, 1)
                   abMenu = False 
                 Debug.Notification("Conjure Mistman Selected")
             ElseIf Button == 5                                                                                     ;Conjure Wrathman
                  selfRef.equipspell(NecroLichConjureWrathman, 1)
                   abMenu = False 
                 Debug.Notification("Conjure Wrathman Selected")        
             ElseIf Button == 6                                                                          
                 Option = 0
             Endif
         ElseIf Option == 3            
             Button = NecroDarkMagicMessage.Show() 
             If Button == 0                                                                                  ;Mass Reanimate
                  selfRef.equipspell(NecroLichRevenant, 1)
                   abMenu = False 
                 Debug.Notification("Mass Reanimate Selected")
             ElseIf Button == 1                                                                            ;Command Undead
                  selfRef.equipspell(NecroLichCommandUndead, 1)
                   abMenu = False 
                 Debug.Notification("Command Undead Selected")
             ElseIf Button == 2                                                                            ;Soul Trap/DeathShroud
                  selfRef.equipspell(NecroLichDeathShroudSpell, 0)
                   abMenu = False 
                 Debug.Notification("Death Shroud Selected")
             ElseIf Button == 3                                                                            ;Necromantic Empowerment
                  selfRef.equipspell(NecroLichHealing, 1)
                   abMenu = False 
                 Debug.Notification("Necromantic Empowerment Selected")
             ElseIf Button == 4                                                                            ;Absorb Magicka
                  selfRef.equipspell(NecroLichAbsorbMagicka, 1)
                   abMenu = False 
                 Debug.Notification("Absorb Magicka Selected")           
             ElseIf Button == 5                                                                            ;Dark Flare
                  selfRef.equipspell(NecroLichDarkFlare, 1)
                   abMenu = False 
                 Debug.Notification("Dark Flare Selected")         
             ElseIf Button == 6                                                                          
                 Option = 0
             Endif
         ElseIf Option == 4            
		     Button = NecroDarkMagic2Message.Show()
             If Button == 0                                                                                ;Mark Of The Worm King
                  selfRef.equipspell(NecroMarkOfTheWormKingSpell, 0)
                   abMenu = False 
                 Debug.Notification("Mark Of The Worm King Selected")
             ElseIf Button == 1                                                                          ;Drain Life
                  selfRef.equipspell(NecroLichDrainLifeSpell, 0)
                   abMenu = False 
                 Debug.Notification("Drain Life Selected")
             ElseIf Button == 2                                                                          ;Soul Corruption
                  selfRef.equipspell(NecroSoulCorruptionSpell, 0)
                   abMenu = False 
                 Debug.Notification("Soul Corruption Selected")
             ElseIf Button == 3                                                                          ;Agony
                  selfRef.equipspell(NecroLichAgonySpell, 0)
                   abMenu = False 
                 Debug.Notification("Agony Selected")
             ElseIf Button == 4                                                                         ;Corpse Implosion
                  selfRef.equipspell(NecroCorpseExplosionSpell, 0)
                   abMenu = False 
                 Debug.Notification("Corpse Implosion Selected")  
		     ElseIf Button == 5                                                                         ;Dark Sacrifice
                  selfRef.equipspell(NecroLichDarkSacrifice, 1)
                   abMenu = False 
                 Debug.Notification("Dark Sacrifice Selected")     
             ElseIf Button == 6                                                                        ;Siphon Soul
                  selfRef.equipspell(NecroSiphonSoulSpell, 0)
                   abMenu = False 
                 Debug.Notification("Siphon Soul Selected")    				 
             ElseIf Button == 7                                                                        
                 Option = 0
             Endif
         ElseIf Option == 5           
		     Button = NecroDiseaseMagicMessage.Show()
             If Button == 0                                                                                ;Withering Affliction
                  selfRef.equipspell(NecroWitheringAfflictionSpell, 0)
                   abMenu = False 
                 Debug.Notification("Withering Affliction Selected")
             ElseIf Button == 1                                                                          ;Curse Of Bonerot
                  selfRef.equipspell(NecroCurseOfBonerot, 0)
                   abMenu = False 
                 Debug.Notification("Curse Of Bonerot Selected")
             ElseIf Button == 2                                                                          ;Curse Of Knightsbane
                  selfRef.equipspell(NecroCurseOfKnightsbane, 0)
                   abMenu = False 
                 Debug.Notification("Curse Of Knightsbane Selected")
             ElseIf Button == 3                                                                          ;Seed Of Pestilence
                  selfRef.equipspell(NecroSeedOfPestilenceSpell, 0)
                   abMenu = False 
                 Debug.Notification("Seed Of Pestilence Selected")
             ElseIf Button == 4                                                                          ;Necrotic Aura
                  selfRef.equipspell(NecroWitheringAuraCloak, 0)
                   abMenu = False 
                 Debug.Notification("Necrotic Aura Selected")  				 
             ElseIf Button == 5                                                                         
                 Option = 0
             Endif
		 ElseIf Option == 6           
		     Button = NecroMindMagicMessage.Show()
             If Button == 0                                                                                
                  selfRef.equipspell(NecroMindBlastSpell, 0)                                    ;Mind Blast
                   abMenu = False 
                 Debug.Notification("Mind Blast Selected")
             ElseIf Button == 1                                                                          ;Psychosis
                  selfRef.equipspell(NecroPsychosisSpell, 0)
                   abMenu = False 
                 Debug.Notification("Psychosis Selected")
             ElseIf Button == 2                                                                          ;Mind Flay
                  selfRef.equipspell(NecroMindFlaySpell, 0)
                   abMenu = False 
                 Debug.Notification("Mind Flay Selected")
             ElseIf Button == 3                                                                          ;Lucid Nightmare
                  selfRef.equipspell(NecroLucidNightmareSpell, 0)
                   abMenu = False 
                 Debug.Notification("Lucid Nightmare Selected")
             ElseIf Button == 4                                                                          ;Ghastly Phantasm
                  selfRef.equipspell(NecroLichGhastlyPhantasm, 0)
                   abMenu = False 
                 Debug.Notification("Ghastly Phantasm Selected")
             ElseIf Button == 5                                                                          ;Whispers Of Madness
                  selfRef.equipspell(NecroWhispersOfMadnessSpell, 0)
                   abMenu = False 
                 Debug.Notification("Whispers Of Madness Selected")
             ElseIf Button == 6                                                                          ;Worm Enthrall
                  selfRef.equipspell(NecroWormEnthrall, 0)
                   abMenu = False 
                 Debug.Notification("Worm Enthrall Selected")        
             ElseIf Button == 7                                                                          
                 Option = 0
             Endif
		 Elseif Option == 7
			 Button = NecroUtilityMagicMessage.Show()
             If Button == 0                                                                                ;Invisibility
                  selfRef.equipspell(NecroLichInvisibility, 1)
                   abMenu = False 
                 Debug.Notification("Invisibility Selected")
             ElseIf Button == 1                                                                          ;Greater Ward
                  selfRef.equipspell(NecroLichWardGreater, 1)
                   abMenu = False 
                 Debug.Notification("Greater Ward Selected")
             ElseIf Button == 2                                                                          ;Candlelight
                  selfRef.equipspell(NecroLichCandlelight, 1)
                   abMenu = False 
                 Debug.Notification("Candlelight Selected")
             ElseIf Button == 3                                                                          ;Detect Aura
                  selfRef.equipspell(NecroLichDetectAura, 1)
                   abMenu = False 
                 Debug.Notification("Detect Aura Selected")
             ElseIf Button == 4                                                                          ;Frost Armor
                  selfRef.equipspell(NecroLichFrostArmor, 1)
                   abMenu = False 
                 Debug.Notification("Frost Armor Selected")
             ElseIf Button == 5                                                                          ;Shockwave
                  selfRef.equipspell(NecroLichShockwave, 1)
                   abMenu = False 
                 Debug.Notification("Shockwave Selected")        
             ElseIf Button == 6                                                                          ;Flesh Ward
                  selfRef.equipspell(NecroLichWardSpell, 0)
                   abMenu = False 
                 Debug.Notification("Flesh Ward Selected")    
             ElseIf Button == 7                                                                          ;Plane Shift
                  selfRef.equipspell(NecroPlaneShiftLichFormSpell, 1)
                   abMenu = False 
                 Debug.Notification("Plane Shift Selected")   
             ElseIf Button == 8                                                                          
                 Option = 0
             Endif
	     Elseif Option == 8      
             Button = NecroInfernalMagicMessage.Show()
             If Button == 0                                                                                ;Infernal Flames
                 selfRef.equipspell(NecroInfernalFlames, 0)
                   abMenu = False 
                 Debug.Notification("Infernal Flames Selected")
             ElseIf Button == 1                                                                          ;Power Overwhelming
                 selfRef.equipspell(NecroPowerOverwhelmingSpell, 0)
                   abMenu = False 
                 Debug.Notification("Power Overwhelming Selected")
             ElseIf Button == 2                                                                          ;Devour Magicka
                  selfRef.equipspell(NecroDevourMagickaSpell, 0)
                   abMenu = False 
                 Debug.Notification("Devour Magicka Selected")
             ElseIf Button == 3                                                                          ;Soul Curse
                  selfRef.equipspell(NecroLichSoulCurse, 0)
                   abMenu = False 
                 Debug.Notification("Soul Curse Selected")
             ElseIf Button == 4                                                                          ;Infernal Surge
                  selfRef.equipspell(NecroInfernalSurgeSpell, 0)
                   abMenu = False 
                 Debug.Notification("Infernal Surge Selected")
             ElseIf Button == 5                                                                          ;Soulfire
                  selfRef.equipspell(NecroLichSoulfireSpell, 0)
                   abMenu = False 
                 Debug.Notification("Soulfire Selected")        
             ElseIf Button == 6                                                                          
                 Option = 0
             Endif
         Endif
     EndWhile
 ENDFUNCTION
                     

