Scriptname LichTransformRitualEffectSCRIPT extends ActiveMagicEffect  

Message Property NecroLeftMagicSelectMessage auto

Quest Property NecroLichRitualQuest auto

GlobalVariable Property PlayerIsVampire Auto
GlobalVariable Property GameHour Auto

Race Property PlayerRace Auto
Race Property LichRace Auto

FormList Property CrimeFactions auto

Quest Property LichTrackingQuest auto

Faction Property HunterFaction  Auto  
Faction Property LichFaction auto

Perk Property NecroPhylacteryRegenPerk auto

Ammo Property NecroLichClearArrow auto

MiscObject Property NecroVyngaldShroud auto
MiscObject Property NecroVyngaldShroudGreen auto
MiscObject Property NecroVyngaldShroudBlack auto

ObjectReference Property Target auto
ObjectReference Property NecroLichTransformRitualTarget001 auto ; the phylacteries that will be assigned as the target
ObjectReference Property NecroLichTransformRitualTarget002 auto ; the phylacteries that will be assigned as the target
Potion Property CurePoison auto

float PlayerHP
float PlayerMG
float PlayerST

Int Property Cycles auto
Int Property RitualLocation auto


;Float Property Health  Auto
;Float Property Magicka  Auto  
;Float Property Stamina Auto

float property fDelay = 0.75 auto
									{time to wait before Spawning Ash Pile}
float property fDelayEnd = 1.65 auto
									{time to wait before Removing Base Actor}
float property ShaderDuration = 4.00 auto
									{Duration of Effect Shader.}
Activator property AshPileObject auto
									{The object we use as a pile.}
EffectShader property MagicEffectShader auto
									{The Effect Shader we want.}
Bool property bSetAlphaZero = True auto
									{The Effect Shader we want.}

Bool Property DLC1HasLightfoot  Auto
Bool Property Soulbound auto
Bool Property doOnce auto
Bool Property Poisoned auto
Perk Property LightFoot  Auto

Explosion Property TransformFXExplosion auto
Explosion Property TransformFXParticles auto
Explosion property FXDragonPriestLargeExplosion auto
Sound Property TransformSoundFX auto
Sound Property NPCNecroLichCloak auto
Sound Property MAGFail auto

VisualEffect property TargetVFX auto
{Visual Effect on Target aiming at Caster}
VisualEffect property CasterVFX auto
{Visual Effect on Caster aming at Target}
EffectShader property CasterFXS auto
{Effect Shader on Caster during Soul trap}
EffectShader property TargetFXS auto
{Effect Shader on Target during Soul trap}

MagicEffect Property AbLichNecroCooldown auto
MagicEffect Property LichTransformRitualPotion auto
Spell Property NecroLichTransformationRitual auto
Spell Property AbLichTransformRitualPotion auto
Spell Property ParalyzeSelf auto

Spell Property AbLichNecroPassive auto
Spell Property DragonPriestAbility auto
Spell Property LichAbility auto
Spell Property LichTransform auto
Spell Property NecroRevert auto
Spell Property NecroLichBlizzard auto
Spell Property IceStormLeftHand auto
Spell Property Revenant auto
Spell Property NecroHealing auto
Spell Property NecroFrostArmor auto
Spell Property IncinerateLeftHand auto
Spell Property SummonSkeleton auto
Spell Property NecroLichLightningStorm auto
Spell Property NecroLichFireStorm auto
Spell Property NecroMassReanimate auto
Spell Property NecroDeathGrip auto
Spell Property DiseaseAtaxia auto
Spell Property DiseaseBoneBreakFever Auto
Spell Property DiseaseBrainRot Auto
Spell Property DiseaseRattles Auto
Spell Property DiseaseRockjoint auto
Spell Property DiseaseWitbane Auto
Spell Property DiseaseSanguinareVampiris Auto

VisualEffect Property DragonPriestParticlesFX auto
VisualEffect Property DragonPriestEyeGlowFX auto

;death effects
ObjectReference property NecroLichRitualXMarkerHeading auto
ObjectReference property NecroLichRitualXMarkerHeading001 auto
ObjectReference property NecroLichRitualXMarkerHeading002 auto
ObjectReference property NecroLichTransformCandle01 auto
ObjectReference property NecroLichTransformationPhylacteryFX auto
ObjectReference property NecroLichTransformationPhylacteryFX001 auto
ObjectReference property NecroLichTransformationPhylacteryFX002 auto
ObjectReference property PlayerDeathFXAct Auto
ObjectReference property NecroLichTransformationPhylacteryLightFX auto
ObjectReference property NecroLichTransformationPhylacteryLightFX001 auto
ObjectReference property NecroLichTransformationPhylacteryLightFX002 auto

Spell property DLC1FXCastVampireBleedSpell Auto
Explosion property PlayerDeathExplosion Auto
Sound property AmbRumbleShake Auto
Sound Property TransformExplosion01  Auto  
Sound Property TransformExplosion02  Auto  
Sound Property TransformExplosion03  Auto  

MusicType Property MUSEclipse  Auto
Idle Property Bleedout  Auto

ImageSpaceModifier property IllusionLightMassiveImod auto

MagicEffect Property NecroRevertEffect auto
MagicEffect Property LichTransformEffect auto

Event OnEffectStart(Actor Target, Actor Caster)

If PlayerIsVampire.GetValue() == 1
Debug.MessageBox("You cannot cast unbind soul as a vampire!")
Else
	PlayerHP = Game.GetPlayer().GetBaseActorValue("health")
	PlayerMG = Game.GetPlayer().GetBaseActorValue("magicka")
	PlayerST = Game.GetPlayer().GetBaseActorValue("stamina")
	Soulbound = true		
	RegisterForUpdate(1)

	;determines the players final Lich appearance based on what items they have
	If (Game.GetPlayer().GetItemCount(NecroVyngaldShroud)) == 1
		(NecroLichRitualQuest as NecroLichTrackingQuest).Shroud = 1
	elseif (Game.GetPlayer().GetItemCount(NecroVyngaldShroudGreen)) == 1
		(NecroLichRitualQuest as NecroLichTrackingQuest).Shroud = 2
	elseif (Game.GetPlayer().GetItemCount(NecroVyngaldShroudBlack)) == 1
		(NecroLichRitualQuest as NecroLichTrackingQuest).Shroud = 3
	else
		(NecroLichRitualQuest as NecroLichTrackingQuest).Shroud = 0
	endif

	RitualLocation = ((NecroLichRitualQuest as NecroLichTrackingQuest).InTrigger) ; current ritual location 0 = none, 1 = tower, 2 = sewer
	If RitualLocation == 1
		Target = NecroLichTransformRitualTarget001 ; Tower phylactery must be enabled
	elseIf RitualLocation == 2
		Target = NecroLichTransformRitualTarget002 ; Sewer phylactery must be enabled
	endif
Endif
EndEvent

Event OnUpdate()

float CurrentHealth = Game.GetPlayer().GetActorValuePercentage("health")

	If (Game.GetPlayer().HasMagicEffect(LichTransformRitualPotion) == 1) && (RitualLocation > 0) && (Poisoned == false) && (doOnce == false) && (Target.IsEnabled() == true) && (NecroLichRitualQuest as NecroLichTrackingQuest).Shroud > 0
		;AbLichTransformRitualPotion.Cast(Game.GetPlayer(), Game.GetPlayer())
		Game.DisablePlayerControls(abMovement = true, abFighting = false, abCamSwitch = true, abMenu = false, abActivate = false, abJournalTabs = false, aiDisablePOVType = 1)
		(NecroLichRitualQuest as NecroLichTrackingQuest).GetPlayerOriginalRace()
		; Ritual effects based on the players location where they are performing the ritual.
		If RitualLocation ==1
			NecroLichTransformationPhylacteryLightFX001.enable()
		elseIf RitualLocation ==2
			NecroLichTransformationPhylacteryLightFX002.enable()
		endif
		Utility.Wait(3)
		Poisoned = true

	;kill the player with the Elixir effect if they lack the ritual prerequisites:

	elseif (Game.GetPlayer().HasMagicEffect(LichTransformRitualPotion) == 1) && (RitualLocation < 1) ;in wrong location
		AbLichTransformRitualPotion.Cast(Game.GetPlayer(), Game.GetPlayer())
	elseif (Game.GetPlayer().HasMagicEffect(LichTransformRitualPotion) == 1) && (Target.IsEnabled() == false) ;phylactery isn't placed
		AbLichTransformRitualPotion.Cast(Game.GetPlayer(), Game.GetPlayer())
	elseif (Game.GetPlayer().HasMagicEffect(LichTransformRitualPotion) == 1) && (NecroLichRitualQuest as NecroLichTrackingQuest).Shroud < 1 ;doesnt have the shroud
		AbLichTransformRitualPotion.Cast(Game.GetPlayer(), Game.GetPlayer())
	endif

;	If (CurrentHealth <= 0.1) && (Soulbound == true) && (Poisoned == true) && (doOnce == false)
	If (Soulbound == true) && (Poisoned == true) && (doOnce == false)
		Game.GetPlayer().PlayIdle(Bleedout)
		RegisterForUpdate(0.8)
		Game.GetPlayer().RestoreActorValue("health", 9999)
		doOnce = true

		If (NecroLichRitualQuest as NecroLichTrackingQuest).Shroud == 1
			Game.GetPlayer().removeitem(NecroVyngaldShroud, 1, true)    
		elseif (NecroLichRitualQuest as NecroLichTrackingQuest).Shroud == 2
			Game.GetPlayer().removeitem(NecroVyngaldShroudGreen, 1, true)   
		elseif (NecroLichRitualQuest as NecroLichTrackingQuest).Shroud == 3
			Game.GetPlayer().removeitem(NecroVyngaldShroudBlack, 1, true)   
		endif
	endif

	If (doOnce == true) && (Poisoned == true) && Cycles <= 13
		;Game.GetPlayer().PushActorAway(Game.GetPlayer(), 0.1)
		Game.GetPlayer().RestoreActorValue("health", 9999)
		Cycles = (Cycles + 1)
	endIf

	If (doOnce == true) && (Cycles == 8)
		;TurnToAsh()
		DeathEffects()
		; Ritual effects based on the players location where they are performing the ritual.
		If RitualLocation ==1
			NecroLichTransformationPhylacteryFX001.enable()
			Game.GetPlayer().placeAtMe(TransformFXExplosion, 1)
			Game.GetPlayer().placeAtMe(TransformFXParticles, 1)
			;MagicEffectShader.play(NecroLichTransformCandle01, ShaderDuration)
		elseIf RitualLocation ==2
			NecroLichTransformationPhylacteryFX002.enable()
			Game.GetPlayer().placeAtMe(TransformFXExplosion, 1)
			Game.GetPlayer().placeAtMe(TransformFXParticles, 1)
			;MagicEffectShader.play(NecroLichTransformCandle01, ShaderDuration)
		endif
	endif

	if (doOnce == true) && (Cycles == 12)
		If RitualLocation ==1
			TransformExplosion01.Play(NecroLichRitualXMarkerHeading001)
			utility.wait(0.3)
			IllusionLightMassiveImod.apply()                                  ; apply isMod at full strength
			TransformExplosion02.Play(NecroLichRitualXMarkerHeading001)
		elseIf RitualLocation ==2
			TransformExplosion01.Play(NecroLichRitualXMarkerHeading002)
			utility.wait(0.3)
			IllusionLightMassiveImod.apply()                                  ; apply isMod at full strength
			TransformExplosion02.Play(NecroLichRitualXMarkerHeading002)
		endif
	endif

	If (doOnce == true) && (Cycles < 10)
		TargetVFX.Play(Game.GetPlayer(),4.7,Target)              ; Play TargetVFX and aim them at the player
		CasterVFX.Play(Target,5.9,Game.GetPlayer())
		TargetFXS.Play(Target,2)    						; Play Effect Shaders
		CasterFXS.Play(Target,3)
	endif

	If (Cycles > 13) && (Poisoned == true)
		UnregisterForUpdate()
		Poisoned = false
		;Game.GetPlayer().placeAtMe(TransformFXExplosion, 1)
		;Game.GetPlayer().placeAtMe(TransformFXParticles, 1)
		;Game.GetPlayer().placeAtMe(FXDragonPriestLargeExplosion, 1)
		;Game.GetPlayer().removespell(AbLichNecroPassive)
		PlayerHP = Game.GetPlayer().GetBaseActorValue("health")
		PlayerMG = Game.GetPlayer().GetBaseActorValue("magicka")
		PlayerST = Game.GetPlayer().GetBaseActorValue("stamina")
		If RitualLocation ==1
			TransformExplosion03.Play(NecroLichRitualXMarkerHeading001)
		elseIf RitualLocation ==2
			TransformExplosion03.Play(NecroLichRitualXMarkerHeading002)
		endif
		Game.GetPlayer().removespell(NecroLichTransformationRitual)
		Game.EnablePlayerControls()
		If RitualLocation ==1
			Game.GetPlayer().moveto(NecroLichRitualXMarkerHeading001)
		elseIf RitualLocation ==2
			Game.GetPlayer().moveto(NecroLichRitualXMarkerHeading002)
		endif
		Game.GetPlayer().RemoveSpell(DiseaseAtaxia)
	    Game.GetPlayer().RemoveSpell(DiseaseBoneBreakFever)
	    Game.GetPlayer().RemoveSpell(DiseaseBrainRot)
	    Game.GetPlayer().RemoveSpell(DiseaseRattles)
	    Game.GetPlayer().RemoveSpell(DiseaseRockjoint)
	    Game.GetPlayer().RemoveSpell(DiseaseWitbane)
	    Game.GetPlayer().RemoveSpell(DiseaseSanguinareVampiris)
		GameHour.Mod(336.0)
		debug.messagebox("A fortnight passes as you bind your soul to the phylactery.")
		Game.GetPlayer().addspell(NecroCurseOfLichdom, false)
		Game.GetPlayer().AddSpell(NecroPerkPhylacteryRegenAbility, false)
		debug.notification("As time passes, you notice your body has slowly decayed into a hollow dried-out shell.")
		Utility.wait(2.0)
		debug.notification("Of your once lively figure only a putrid corpse remains.")
		Utility.wait(2.0)
		debug.notification("Yet as you adjust to your ghastly state of undeath,")
		Utility.wait(2.0)
		debug.notification("it dawns on you that you have achieved what all that perceive seek : Immortality.")
		Utility.Wait(3.0)
		LichTransform.cast(Game.GetPlayer(), Game.GetPlayer())
		MagicEffectShader.play(Game.GetPlayer(),ShaderDuration)
		utility.wait(fDelay)
		utility.wait(fDelayEnd)
		MagicEffectShader.stop(Game.GetPlayer())
		debug.notification("You have attained lichdom!")
		IllusionLightMassiveImod.remove()
		;NecroLichTransform()

		If RitualLocation ==1
			NecroLichTransformationPhylacteryLightFX001.Disable(1)
			NecroLichTransformationPhylacteryFX001.Enable()
		elseIf RitualLocation ==2
			NecroLichTransformationPhylacteryLightFX002.Disable(1)
			NecroLichTransformationPhylacteryFX002.Enable()
		endif

		NecroLichRitualQuest.SetStage(90)
		Utility.Wait(5)
		PlayerDeathFXAct.disable(true)
		Game.GetPlayer().addPerk(NecroPhylacteryRegenPerk)
		Game.GetPlayer().addPerk(NecroLichResistances)
		Game.GetPlayer().addPerk(NecroLichNoFoodAndPotionEffect)
		NecroLichRitualQuest.SetCurrentStageID(100)
		debug.notification("Use the Sneak key to open the spell menu.")
	endif

EndEvent

Function DeathEffects()

		;Begin disintegration and vfx.
		DLC1FXCastVampireBleedSpell.Cast(Game.GetPlayer(), Game.GetPlayer())
		PlayerDeathFXAct.enable(true)
		Game.GetPlayer().ClearExtraArrows()
		Utility.Wait(1)
		AmbRumbleShake.Play(Game.GetPlayer())
		Game.GetPlayer().RampRumble(1, 2, 1600)
		Game.ShakeCamera(Game.GetPlayer(), 1, 2)
		Game.GetPlayer().PlaceAtMe(PlayerDeathExplosion)
		;Wait for Player to collapse.
		Utility.Wait(4)

EndFunction

bool Function TurnToAsh()
		;Game.GetPlayer().SetAlpha (0.99,False)
		MagicEffectShader.play(Game.GetPlayer(),ShaderDuration)
		;utility.wait(fDelay)     
		;utility.wait(fDelayEnd)
		;MagicEffectShader.stop(Game.GetPlayer())
		;Game.GetPlayer().SetAlpha (0.0,True)
endFunction



GlobalVariable Property GameDay Auto  


Spell Property NecroCurseOfLichdom Auto

Perk Property NecroLichResistances Auto

Perk Property NecroLichNoFoodAndPotionEffect Auto

Spell Property NecroPerkPhylacteryRegenAbility Auto
