Scriptname NecroLichTransformSCRIPT extends ActiveMagicEffect  

Message Property NecroLeftMagicSelectMessage auto

Quest Property NecroLichRitualQuest auto
Quest Property NecroTrackingQuest auto
Quest Property PlayerVampireQuest auto
Quest Property C00 auto

GlobalVariable Property pDLC1VQ04SafeToEnter Auto
GlobalVariable Property PlayerIsVampire Auto

Race Property PlayerRace Auto
Race Property LichRace Auto

FormList Property CrimeFactions auto

Quest Property LichTrackingQuest auto

Faction Property HunterFaction  Auto  
Faction Property LichFaction auto

Ammo Property NecroLichClearArrow auto

Armor Property NecroLichSkin01 auto
Armor Property NecroLichSkin02 auto
Armor Property NecroLichSkin03 auto
Armor Property NecroLichSkin04 auto
Armor Property NecroLichSkin05 auto
Armor Property NecroLichSkin06 auto
Armor Property NecroLichSkin07 auto
Armor Property NecroLichSkin08 auto
Armor Property NecroLichSkin09 auto
Armor Property NecroLichSkin10 auto
Armor Property NecroLichSkin11 auto

float PlayerHP
float PlayerMG
float PlayerST

;Float Property Health  Auto
;Float Property Magicka  Auto  
;Float Property Stamina Auto 

Bool Property DLC1HasLightfoot  Auto
Bool Property Transforming auto
Perk Property LightFoot  Auto  

Explosion Property TransformFXExplosion auto
Explosion Property TransformFXParticles auto
Explosion property FXDragonPriestLargeExplosion auto
Sound Property TransformSoundFX auto
Sound Property NPCNecroLichCloak auto
Sound Property MAGFail auto

MagicEffect Property AbLichNecroCooldown auto

Spell Property AbLichNecroPassive auto
Spell Property DragonPriestAbility auto
Spell Property LichAbility auto
Spell Property LichTransform auto
Spell Property NecroRevert auto
Spell Property NecroLichBlizzard auto
Spell Property IceStormLeftHand auto
Spell Property Revenant auto
Spell Property NecroHealing auto
Spell Property NecroFrostArmor auto
Spell Property IncinerateLeftHand auto
Spell Property SummonSkeleton auto
Spell Property NecroLichLightningStorm auto
Spell Property NecroLichFireStorm auto
Spell Property NecroMassReanimate auto
Spell Property NecroDeathGrip auto
Spell Property DiseaseAtaxia auto
Spell Property DiseaseBoneBreakFever Auto
Spell Property DiseaseBrainRot Auto
Spell Property DiseaseRattles Auto
Spell Property DiseaseRockjoint auto
Spell Property DiseaseWitbane Auto
Spell Property DiseaseSanguinareVampiris Auto
Spell Property WerewolfChange Auto
Spell Property DLC1VampireChange Auto

ImageSpaceModifier property IllusionLightMassiveImod auto

MagicEffect Property NecroRevertEffect auto
MagicEffect Property LichTransformEffect auto

EffectShader Property NecroLichTransformPlayerFireFXShort auto

actor TheLich

Event OnEffectStart(Actor AkTarget, Actor AkCaster)

TheLich = AkCaster

if (TheLich.GetRace() != LichRace)
	if (akTarget == TheLich && Transforming == false && TheLich.HasMagicEffect(AbLichNecroCooldown) == 0)
	        Debug.ToggleCollisions()
	        Game.DisablePlayerControls(abMovement = false, abFighting = false, abCamSwitch = true, abMenu = false, abActivate = false, abJournalTabs = false, aiDisablePOVType = 1)
			IllusionLightMassiveImod.apply()                                  ; apply isMod at full strength
			NecroLichTransformPlayerFireFXShort.Play(TheLich,0.5)
			TheLich.placeAtMe(TransformFXExplosion, 1)
			TheLich.placeAtMe(TransformFXParticles, 1)
			TheLich.placeAtMe(FXDragonPriestLargeExplosion, 1)
			TheLich.removespell(AbLichNecroPassive)
			PlayerHP = TheLich.GetBaseActorValue("health")
			PlayerMG = TheLich.GetBaseActorValue("magicka")
			PlayerST = TheLich.GetBaseActorValue("stamina")
			Transforming = true		
			NecroLichTransform()
		else
			MAGFail.Play(TheLich)
			debug.notification("Lich Transformation is not yet ready.")
			Game.SetBeastForm(false)
		endif
endif

EndEvent


Function NecroLichTransform()

    	; Preload the spells the player can equip.
    	PreloadSpells()
 
	;Clear player's diseases
	;VampireCureDisease.Cast(Target)
;	Classical Lichdom - These are unnecessary since you have a 100% disease resist passive. These will now be removed by the lich ritual script during your lich ritual.
;	TheLich.RemoveSpell(WerewolfChange)
;	TheLich.RemoveSpell(DLC1VampireChange)
;	TheLich.RemoveSpell(DiseaseBoneBreakFever)
;	TheLich.RemoveSpell(DiseaseBrainRot )
;	TheLich.RemoveSpell(DiseaseRattles )
;	TheLich.RemoveSpell(DiseaseRockjoint )
;	TheLich.RemoveSpell(DiseaseWitbane )
;	TheLich.RemoveSpell(DiseaseSanguinareVampiris)

;	Classical Lichdom : These cures should only be run IF the player has lycanthropy or vampirism, not all the time!
	If PlayerIsVampire.GetValue() != 0
	(PlayerVampireQuest as PlayerVampireQuestScript).VampireCure(TheLich)
	EndIf
	If TheLich.HasSpell(WerewolfChange)
	(C00 as CompanionsHousekeepingScript).CurePlayer()
    EndIf
	
	
;	;Classical Lichdom - These are unnecessary since later statements in this script will equip you with a power and spells for both hands.
;	Spell left = TheLich.GetEquippedSpell(0)
;	Spell right = TheLich.GetEquippedSpell(1)
;	Spell power = TheLich.GetEquippedSpell(2)
;	Shout voice = TheLich.GetEquippedShout()
;	if (left != None)
;        	TheLich.UnequipSpell(left, 0)
;    	endif
;    	if (right != None)
;        	TheLich.UnequipSpell(right, 1)
;    	endif
;	if (power != None)
;       ; some players are overly clever and sneak a power equip between casting
;        ;  beast form and when we rejigger them there. this will teach them.
;	;  Debug.Trace("WEREWOLF: " + power + " was equipped; removing.")
;		TheLich.UnequipSpell(power, 2)
;    	else
;         Debug.Trace("WEREWOLF: No power equipped.")
;    	endif
;	if (voice != None)
;       ; same deal here, but for shouts
;         Debug.Trace("WEREWOLF: " + voice + " was equipped; removing.")
;		TheLich.UnequipShout(voice)
;	else
;         Debug.Trace("WEREWOLF: No shout equipped.")
;	endif
;
	; unequip weapons
	TheLich.equipitem(NecroLichClearArrow, false, true)
    TheLich.removeitem(NecroLichClearArrow, 1, true)
	Weapon wleft = TheLich.GetEquippedWeapon(true)
	Weapon wright = TheLich.GetEquippedWeapon(false)

	
	if (TheLich.GetEquippedItemType(1) == 8)
		(NecroTrackingQuest as NecroTrackingQuestSCRIPT).Staff = wright
		;debug.notification("player has staff")
;		TheLich.UnequipItem(wright, false, true)
	else
		(NecroTrackingQuest as NecroTrackingQuestSCRIPT).Staff = None
		;debug.notification("player doesnt have staff")
;		TheLich.UnequipItem(wright, false, true)
	endif

;	if (wleft != None)
;		TheLich.UnequipItem(wleft, false, true)
;	endif
;	if (wright != None)
;        TheLich.UnequipItem(wright, false, true)
; 	endif
 
	TheLich.SetGhost(true)
	Game.ForceThirdPerson()
	Game.SetBeastForm(True)
	Game.ShowFirstPersonGeometry(false)
	Game.EnableFastTravel(False)
	TheLich.SetRace(LichRace)
	TransformSoundFX.Play(TheLich)
	NPCNecroLichCloak.Play(TheLich)
	
	
	TheLich.SetActorValue("health", (PlayerHP))
	;Debug.notification("LICH: Player health changed to" + PlayerHP)
	TheLich.SetActorValue("magicka", (PlayerMG))
	;Debug.notification("LICH: Player magicka changed to" + PlayerMG)
	TheLich.SetActorValue("stamina", (PlayerST))
	TheLich.ModActorValue("MagickaRate", 12)
	TheLich.RestoreActorValue("magicka", 100)
	TheLich.RestoreActorValue("stamina", -999999999999)
	TheLich.RestoreActorValue("health", 50)
	;TheLich.SetActorValue("healrate", 1)
   
	 ; set up perks/abilities
    	TheLich.SetActorValue("GrabActorOffset", 70)

    	if (TheLich.HasPerk(Lightfoot) == true)
        	DLC1HasLightfoot = true
    	else
        	DLC1HasLightfoot = false
        	TheLich.AddPerk(Lightfoot)
    	endif

;	TheLich.addspell(LichAbility, false)
	TheLich.addspell(NecroRevert, false)
	TheLich.equipspell(NecroRevert, 2)
;	TheLich.addspell(NecroLichBlizzard, false)
;	TheLich.addspell(IceStormLeftHand, false)
;	TheLich.addspell(IncinerateLeftHand, false)
;	TheLich.addspell(NecroHealing, false)
;	TheLich.addspell(NecroFrostArmor, false)
;	TheLich.addspell(SummonSkeleton, false)
;	TheLich.addspell(Revenant, false)
	TheLich.addspell(NecroDeathGrip, false)
	TheLich.equipspell(IncinerateLeftHand, 1)
;	TheLich.addspell(NecroLichLightningStorm, false)
;	TheLich.addspell(NecroLichFireStorm, false)
;	TheLich.addspell(NecroMassReanimate, false)
;	TheLich.removespell(DragonPriestAbility)


	if (NecroLichRitualQuest as NecroLichTrackingQuest).Shroud == 1 && (NecroLichRitualQuest as NecroLichTrackingQuest).Flesh == 1
		;transform the player into the red flesh lich
		TheLich.EquipItem(NecroLichSkin01,  False, True)
	elseif (NecroLichRitualQuest as NecroLichTrackingQuest).Shroud == 1 && (NecroLichRitualQuest as NecroLichTrackingQuest).Flesh == 0
		;transform the player into the red skeletal lich
		TheLich.EquipItem(NecroLichSkin05,  False, True)
	elseif (NecroLichRitualQuest as NecroLichTrackingQuest).Shroud == 2 && (NecroLichRitualQuest as NecroLichTrackingQuest).Flesh == 1
		;transform the player into the green flesh lich
		TheLich.EquipItem(NecroLichSkin02,  False, True)
	elseif (NecroLichRitualQuest as NecroLichTrackingQuest).Shroud == 2 && (NecroLichRitualQuest as NecroLichTrackingQuest).Flesh == 0
		;transform the player into the green skeletal lich
		TheLich.EquipItem(NecroLichSkin06,  False, True)
	elseif (NecroLichRitualQuest as NecroLichTrackingQuest).Shroud == 3 && (NecroLichRitualQuest as NecroLichTrackingQuest).Flesh == 1
		;transform the player into the black flesh lich
		TheLich.EquipItem(NecroLichSkin09,  False, True)
	elseif (NecroLichRitualQuest as NecroLichTrackingQuest).Shroud == 3 && (NecroLichRitualQuest as NecroLichTrackingQuest).Flesh == 0
		;transform the player into the black skeletal lich
		TheLich.EquipItem(NecroLichSkin11,  False, True)
	endif
	
    Debug.ToggleCollisions()
	
;	If ((NecroTrackingQuest as NecroTrackingQuestSCRIPT).Staff != None)
;		TheLich.additem((NecroTrackingQuest as NecroTrackingQuestSCRIPT).Staff, 1, 1)
;		;debug.notification("adding stored staff")
;	endif

	If ((NecroTrackingQuest as NecroTrackingQuestSCRIPT).Staff != None) ; Give the player their right hand staff back, if there was one
		;debug.notification("equipping players staff")
		TheLich.EquipItem((NecroTrackingQuest as NecroTrackingQuestSCRIPT).Staff, false, True) ;equip the players staff they had in their right hand from earlier
	    TheLich.DrawWeapon()
		Debug.SendAnimationEvent(TheLich, "Magic_Equip")
	elseif ((NecroTrackingQuest as NecroTrackingQuestSCRIPT).Staff == None) ; If no staff was stored earlier, give the player the default right hand spell
		;debug.notification("not equipping staff")
		TheLich.equipspell(NecroDeathGrip, 1)
		TheLich.DrawWeapon()
		Debug.SendAnimationEvent(TheLich, "Magic_Equip")
	endif

   	; make everyone hate you
    	TheLich.SetAttackActorOnSight(true)

    	; alert anyone nearby that they should now know the player is a lich
   	Game.SendWereWolfTransformation()

    	TheLich.AddToFaction(LichFaction)
	pDLC1VQ04SafeToEnter.SetValue(1)

   	 int cfIndex = 0
    	while (cfIndex < CrimeFactions.GetSize())
        	Debug.Trace("VAMPIRE: Setting enemy flag on " + CrimeFactions.GetAt(cfIndex))
        	(CrimeFactions.GetAt(cfIndex) as Faction).SetPlayerEnemy()
        	cfIndex += 1
    	endwhile
    	HunterFaction.SetPlayerEnemy()

    	; but they also don't know that it's you
   	Game.SetPlayerReportCrime(false)

	TheLich.SetGhost(false)
	TheLich.removespell(LichTransform)

EndFunction

; Preload all of the spells that could be equipped to the left or right hand. This will
; prevent a delay after EquipSpell before the casting art is loaded.
; This should be called when we start the script.
Function PreloadSpells()
	Revenant.Preload()
	IncinerateLeftHand.Preload()
	IceStormLeftHand.Preload()
	NecroHealing.Preload()
	NecroFrostArmor.Preload()
	NecroDeathGrip.Preload()
    NecroLichBlizzard.Preload()
    NecroLichLightningStorm.Preload()
   	NecroLichFireStorm.Preload()
EndFunction

; Unload all of the spells the player could equip.
; This should be called when we shut the script down.
Function UnloadSpells()
	IceStormLeftHand.Unload()
	NecroHealing.Unload()
	NecroDeathGrip.Unload()
    	NecroLichBlizzard.Unload()
    	NecroLichLightningStorm.Unload()
    	NecroLichFireStorm.Unload()
EndFunction
