Scriptname NecroRevertEffectSCRIPT extends ActiveMagicEffect  

Race Property PlayerOriginalRace Auto
;Race Property BretonRace Auto
Race Property LichRace Auto

FormList Property CrimeFactions auto

Quest Property NecroLichRitualQuest auto
Quest Property NecroTrackingQuest auto
Faction Property HunterFaction  Auto  
Faction Property LichFaction auto

Weapon Property NecroStaffOfWorms auto
Weapon Property NecroLesserStaffOfWorms auto
Armor Property ClothesBeggarRobes auto
Armor Property NecroLichSkin01 auto
Armor Property NecroLichSkin02 auto
Armor Property NecroLichSkin03 auto
Armor Property NecroLichSkin04 auto
Armor Property NecroLichSkin05 auto
Armor Property NecroLichSkin06 auto
Armor Property NecroLichSkin07 auto
Armor Property NecroLichSkin08 auto
Armor Property NecroLichSkin09 auto
Armor Property NecroLichSkin10 auto
Armor Property NecroLichSkin11 auto

float PlayerHP
float PlayerMG
float PlayerST

Int Property HP  Auto
Int Property Magicka  Auto  
Int Property Stamina  Auto 

Explosion Property TransformFXExplosion auto
Explosion Property TransformFXParticles auto
Explosion Property FXDragonPriestLargeExplosion auto

VisualEffect Property DragonPriestParticlesFX Auto
{Floor based stream of upward particles}

VisualEffect Property DragonPriestEyeGlowFX Auto
{eye glow fx}

VisualEffect Property FXfallingSandDragonPriestEffect Auto
{falling sand from holes fx}

Bool Property DLC1HasLightfoot  Auto
Bool Property Transforming auto
Perk Property LightFoot  Auto  

Spell property DLC1FXCastVampireBleedSpell Auto

Spell Property AbLichNecroPassive auto
Spell Property DragonPriestAbility auto
Spell Property LichAbility auto
Spell Property LichTransform auto
Spell Property NecroRevert auto
Spell Property LichBlizzard auto
Spell Property NecroFrostArmor auto
Spell Property IncinerateLeftHand auto
Spell Property NecroHealing auto
Spell Property IceStormLeftHand auto
Spell Property Revenant auto
Spell Property LichLightningStorm auto
Spell Property LichFireStorm auto
Spell Property AbLichNecroCooldown auto
Spell Property NecroDeathGrip auto
Spell Property DiseaseAtaxia auto
Spell Property DiseaseBoneBreakFever Auto
Spell Property DiseaseBrainRot Auto
Spell Property DiseaseRattles Auto
Spell Property DiseaseRockjoint auto
Spell Property DiseaseWitbane Auto
Spell Property DiseaseSanguinareVampiris Auto

EffectShader Property NecroLichTransformPlayerFireFXShort auto

MagicEffect Property NecroRevertEffect auto
MagicEffect Property LichTransformEffect auto

actor TheLich

Event OnEffectStart(Actor akTarget, Actor akCaster)

TheLich = akCaster

if (TheLich.GetRace() == LichRace && Transforming == false)
	Debug.Trace("LICH: Casting transformation spell on " + akTarget)

	; set up tracking
	if (akTarget == TheLich)
		;DLC1FXCastVampireBleedSpell.Cast(TheLich, TheLich)
		NecroLichTransformPlayerFireFXShort.Play(TheLich,0.5)
		TheLich.placeAtMe(TransformFXExplosion, 1)
		TheLich.placeAtMe(TransformFXParticles, 1)
		TheLich.placeAtMe(FXDragonPriestLargeExplosion, 1)
		TheLich.addspell(AbLichNecroPassive, false)
		PlayerHP = TheLich.GetBaseActorValue("health")
		PlayerMG = TheLich.GetBaseActorValue("magicka")
		PlayerST = TheLich.GetBaseActorValue("stamina")
		Transforming = true
		Revert()
	endif
else
endif

EndEvent

Function Revert()

	TheLich.SetGhost(true)
;     Debug.Trace("LICH: Revert effect detected")
	TheLich.RemoveFromFaction(LichFaction)
    	if DLC1HasLightfoot == false
        	TheLich.RemovePerk(Lightfoot)
    	endif

    ; make sure your health is reasonable before turning you back
    float currHealth = TheLich.GetAV("health")
    if (currHealth <= 70)
        Debug.Trace("VAMPIRE: Player's health is only " + currHealth + "; restoring.")
        TheLich.RestoreAV("health", 70 - currHealth)
    endif

    	; change you back
    	;TheLich.RemoveItem(NecroLichForm, 2, true)

	if (NecroLichRitualQuest as NecroLichTrackingQuest).Shroud == 1 && (NecroLichRitualQuest as NecroLichTrackingQuest).Flesh == 1
		;transform the player into the red flesh lich
		TheLich.RemoveItem(NecroLichSkin01,  1, True)
	elseif (NecroLichRitualQuest as NecroLichTrackingQuest).Shroud == 1 && (NecroLichRitualQuest as NecroLichTrackingQuest).Flesh == 0
		;transform the player into the red skeletal lich
		TheLich.RemoveItem(NecroLichSkin05,  1, True)
	elseif (NecroLichRitualQuest as NecroLichTrackingQuest).Shroud == 2 && (NecroLichRitualQuest as NecroLichTrackingQuest).Flesh == 1
		;transform the player into the green flesh lich
		TheLich.RemoveItem(NecroLichSkin02,  1, True)
	elseif (NecroLichRitualQuest as NecroLichTrackingQuest).Shroud == 2 && (NecroLichRitualQuest as NecroLichTrackingQuest).Flesh == 0
		;transform the player into the green skeletal lich
		TheLich.RemoveItem(NecroLichSkin06,  1, True)
	elseif (NecroLichRitualQuest as NecroLichTrackingQuest).Shroud == 3 && (NecroLichRitualQuest as NecroLichTrackingQuest).Flesh == 1
		;transform the player into the black flesh lich
		TheLich.RemoveItem(NecroLichSkin09,  1, True)
	elseif (NecroLichRitualQuest as NecroLichTrackingQuest).Shroud == 3 && (NecroLichRitualQuest as NecroLichTrackingQuest).Flesh == 0
		;transform the player into the black skeletal lich
		TheLich.RemoveItem(NecroLichSkin11,  1, True)
	endif

	DragonPriestEyeGlowFX.Stop(TheLich)
	DragonPriestParticlesFX.Stop(TheLich)
	FXfallingSandDragonPriestEffect.Stop(TheLich)

   	TheLich.SetRace((NecroLichRitualQuest as NecroLichTrackingQuest).playerOriginalRace)
	;TheLich.EquipItem(ClothesBeggarRobes,  False, True)

	TheLich.removespell(IceStormLeftHand)
	TheLich.removespell(IncinerateLeftHand)
	TheLich.removespell(NecroFrostArmor)
	TheLich.removespell(NecroHealing)
	TheLich.removespell(LichBlizzard)
	TheLich.removespell(LichLightningStorm)
	TheLich.removespell(LichFireStorm)
	TheLich.removespell(LichAbility)
	TheLich.removespell(NecroDeathGrip)

	Spell right = TheLich.GetEquippedSpell(1)
	if (right != Revenant)
        	TheLich.UnequipSpell(right, 1)
	endif

	TheLich.addspell(LichTransform, false)
	TheLich.equipspell(LichTransform, 2)
    Debug.MessageBox("Using illusion magic, you disguise your true form to mask your rotting visage")
   	Game.EnablePlayerControls(abMovement = false, abFighting = false, abCamSwitch = true, abLooking = false, abSneaking = false, abMenu = false, abActivate = false, abJournalTabs = false, aiDisablePOVType = 1)
    	Game.ShowFirstPersonGeometry(true)

        TheLich.SetAttackActorOnSight(false)
        HunterFaction.SetPlayerEnemy(false)
        TheLich.RemoveFromFaction(LichFaction)
        int cfIndex = 0
        while (cfIndex < CrimeFactions.GetSize())
            ;Debug.Trace("LICH: Removing enemy flag from " + CrimeFactions.GetAt(cfIndex))
            (CrimeFactions.GetAt(cfIndex) as Faction).SetPlayerEnemy(false)
            cfIndex += 1
        endwhile
 ;   endif

    	;and you're now recognized
    	Game.SetPlayerReportCrime(true)

; 	alert anyone nearby that they should now know the player is a vampire
	Game.SendWereWolfTransformation()
	
	
	;Utility.Wait(0.5)

	TheLich.SetActorValue("health", (PlayerHP))
	;Debug.notification("LICH: Player health changed to " + PlayerHP)
	TheLich.SetActorValue("magicka", (PlayerMG))
	;Debug.notification("LICH: Player magicka changed to " + PlayerMG)
	TheLich.SetActorValue("stamina", (PlayerST))
	TheLich.ModActorValue("MagickaRate", -12)

	TheLich.RestoreActorValue("health", 70)
	TheLich.RestoreActorValue("stamina", 50)
	TheLich.SetScale (1.0)

    ; give the set race event a chance to come back, otherwise shut us down
    	;Utility.Wait(5)
    	Debug.Trace("OnRaceSwitchComplete event took more than 5 seconds, shutting down ourselves.")
;    	Shutdown()

	Transforming = false
	Game.SetBeastForm(false)
	Game.EnableFastTravel()
	TheLich.addspell(NecroCurseOfLichdom, false)
	TheLich.SetGhost(false)
	AbLichNecroCooldown.Cast(TheLich)

	TheLich.removespell(NecroRevert)

EndFunction


Spell Property NecroCurseOfLichdom auto