Scriptname NecroTrackingQuestSCRIPT extends Quest  

int property GameDay auto
int property CurrentDay auto
int property Daytimer auto
bool property Halo auto

Weapon Property Staff auto

GlobalVariable Property NecroPerkPhylacteryRegenTimer auto
GlobalVariable Property GameDaysPassed auto

Perk Property NecroMassReanimatePerk Auto

Activator property AshPileObject auto

int PlayerMagickaRate

Event OnInit()

	;sets the first day of the shades apearance to the current day
	GameDay = Utility.GetCurrentGameTime() As Int
	CurrentDay = GameDay
	;debug.notification("GameDay =" + GameDay + "days")
	Halo = True
	RegisterForSingleUpdate(30.0)
	;debug.notification("Registering for tracking update")

	;Add the MassReanimate perk for the player OnInit
	if (Game.GetPlayer().HasPerk(NecroMassReanimatePerk) == 0)
		Game.GetPlayer().addperk(NecroMassReanimatePerk)
	else
	endif

EndEvent

Event OnUpdate()

GameDay = Utility.GetCurrentGameTime() As Int

;Add the MassReanimate perk incase the player didn't get it OnInit
If (Game.GetPlayer().HasPerk(NecroMassReanimatePerk) == 0)
	Game.GetPlayer().addperk(NecroMassReanimatePerk)
else
endif

;Disable the shade if the day is passed
If (Halo == True)
	if (CurrentDay != GameDay)
		;disable the shade and start a timer for the next 7 days
		Halo = False
		;debug.notification("NecroTrackingQuest: Halo is false")
		Daytimer = 0
		;update for the new day
		GameDay = Utility.GetCurrentGameTime() As Int
		CurrentDay = GameDay
	endif
	;debug.notification("NecroTrackingQuest: Shade is active")
	;debug.notification("GameDay =" + GameDay + "days")
	;debug.notification("CurrentDay =" + CurrentDay + "days")
endif

;If the shade is not up, start it up again in 8 ingame days
if (CurrentDay != GameDay)
	if (DayTimer < 7)
		Daytimer = Daytimer + 1
		;debug.notification("Daytimer =" + Daytimer + "days")
		GameDay = Utility.GetCurrentGameTime() As Int
		CurrentDay = GameDay
	else
		Halo = True
		;debug.notification("NecroTrackingQuest: Halo is true, daytimer reset")
		Daytimer = 0
		GameDay = Utility.GetCurrentGameTime() As Int
		CurrentDay = GameDay
	endif
endif

RegisterForSingleUpdate(30.0)

EndEvent

function MovePlayerHome(bool bHealPlayer = false)
; 	debug.trace(self + "MovePlayerHome START: bHealPlayer=" + bHealPlayer)
	Actor player = Game.GetPlayer()
	player.GetActorBase().SetInvulnerable(true)
	Game.GetPlayer().removespell(NecroPerkPhylacteryRegenAbility)

;	if !bHealPlayer
;		DLC2ApocryphaRewardBookEnter.Apply()
;		utility.wait(1.5)
;		DLC2ApocryphaRewardBookEnter.PopTo(FadeToBlackHoldImod)
;	EndIf

	if bHealPlayer
		; restore health
		player.RestoreActorValue("Health", 9999)
; 		debug.trace(self + "MovePlayerHome: healed player - current health= " + player.getActorValue("Health"))
	endif

	; TEST 93097 - get equipped spells
	Spell leftSpell = player.GetEquippedSpell(0)
	Spell rightSpell = player.GetEquippedSpell(1)
; 	debug.trace(self + " spells equipped: left hand=" + leftSpell + ", right hand=" + rightSpell)

	If (NecroLichTransformationRitualTarget01.IsEnabled() == 1)
		Game.GetPlayer().moveto(NecroLichRitualXMarkerHeading001)
		NecroLichTransformationPhylacteryFX001.Enable()
	elseIf (NecroLichTransformationRitualTarget02.IsEnabled() == 1)
		Game.GetPlayer().moveto(NecroLichRitualXMarkerHeading002)
		NecroLichTransformationPhylacteryFX002.Enable()
	endif
	
	If (Game.GetPlayer().GetRace() != LichRace)
	   Game.GetPlayer().UnequipAll()
    Endif
	
;	Game.GetPlayer().moveto(NecroLichRitualXMarkerHeading001)
	Game.GetPlayer().UnequipItem(SkinSkeletonNecroPriest, False, True)
;	NecroLichTransformPlayerFireFXShort.Play(Game.GetPlayer(),0.5)

	if (NecroLichRitualQuest as NecroLichTrackingQuest).Shroud == 1 && (NecroLichRitualQuest as NecroLichTrackingQuest).Flesh == 1
		;transform the player into the red flesh lich
		Game.GetPlayer().EquipItem(NecroLichSkin01,  False, True)
	elseif (NecroLichRitualQuest as NecroLichTrackingQuest).Shroud == 1 && (NecroLichRitualQuest as NecroLichTrackingQuest).Flesh == 0
		;transform the player into the red skeletal lich
		Game.GetPlayer().EquipItem(NecroLichSkin05,  False, True)
	elseif (NecroLichRitualQuest as NecroLichTrackingQuest).Shroud == 2 && (NecroLichRitualQuest as NecroLichTrackingQuest).Flesh == 1
		;transform the player into the green flesh lich
		Game.GetPlayer().EquipItem(NecroLichSkin02,  False, True)
	elseif (NecroLichRitualQuest as NecroLichTrackingQuest).Shroud == 2 && (NecroLichRitualQuest as NecroLichTrackingQuest).Flesh == 0
		;transform the player into the green skeletal lich
		Game.GetPlayer().EquipItem(NecroLichSkin06,  False, True)
	elseif (NecroLichRitualQuest as NecroLichTrackingQuest).Shroud == 3 && (NecroLichRitualQuest as NecroLichTrackingQuest).Flesh == 1
		;transform the player into the black flesh lich
		Game.GetPlayer().EquipItem(NecroLichSkin09,  False, True)
	elseif (NecroLichRitualQuest as NecroLichTrackingQuest).Shroud == 3 && (NecroLichRitualQuest as NecroLichTrackingQuest).Flesh == 0
		;transform the player into the black skeletal lich
		Game.GetPlayer().EquipItem(NecroLichSkin11,  False, True)
	endif

	FXfallingSandDragonPriestEffect.Stop(Game.GetPlayer())

	;player.MoveTo(TamrielMarker)
	FadeToBlackHoldImod.PopTo(DLC2ApocryphaRewardBookExit)
	DLC2ApocryphaRewardBookExit.Remove()
	;failsafe
	DLC2ApocryphaRewardBookEnter.Remove()
	FadeToBlackHoldImod.Remove()
	If (Game.GetPlayer().HasPerk(NecroMagicalAptitude) == 1)
		GameHour.Mod(96.0)
		Debug.Messagebox("Four days have passed since your defeat.")
	Else
	    GameHour.Mod(168.0)
	    Debug.Messagebox("Seven days have passed since your defeat.")
	Endif
	; clear from alias - make sure healed first as a failsafe for water damage
	if player.GetActorValue("Health") < 0
		; restore health
		player.RestoreActorValue("Health", 9999)
; 		debug.trace(self + "MovePlayerHome: healed player - current health= " + player.getActorValue("Health"))
	endif
	PlayerAlias.Clear()
	If (Game.GetPlayer().GetRace() == LichRace)
	  Game.GetPlayer().equipspell(NecroLichIncinerate, 0)
	  Game.GetPlayer().equipspell(NecroDeathGrip, 1)
	  Game.GetPlayer().equipspell(NecroRevert, 2)
	Endif
	player.GetActorBase().SetInvulnerable(false)
	Game.GetPlayer().AddSpell(NecroPerkPhylacteryRegenAbility, false)
	Game.EnablePlayerControls()
	
	; TEST - wait
	utility.wait(3.0)
	; test to fix equip bug 93097
;	int ileftHand = player.GetEquippedItemType(0)
;	int iRightHand = player.GetEquippedItemType(1)
; 	debug.trace(self + " item type equipped: left hand=" + ileftHand + ", right hand=" + iRightHand)
	; if nothing in hand still (or staff), set graph variables to make sure animation is cleared
;	if iLeftHand == 8
;		player.UnequipItem(player.GetEquippedWeapon(true), false, true)
;	elseif iLeftHand == 0
;		player.SetAnimationVariableInt("iLeftHandType", 0)
;	EndIf

;	if iRightHand == 8
;		player.UnequipItem(player.GetEquippedWeapon(false), false, true)
;	elseif iRightHand == 0
;		player.SetAnimationVariableInt("iRightHandType", 0)
;	EndIf
	; END TEST


endFunction

Function PlayerInBleedout()

; ;	debug.trace(self + " Enter Bleedout");	
	If (Game.GetPlayer().HasPerk(NecroPhylacteryRegenPerk) == 1) && (Game.GetPlayer().GetRace() == LichRace)
		; Let the player 'die' in bleedout and then teleport them to the phylactery
		;Game.GetPlayer().SetGhost(true)
;		NecroPerkPhylacteryRegenTimer.SetValue(GameDaysPassed.GetValue() + 0.0)
;		Game.GetPlayer().GetActorBase().SetInvulnerable(true)
;		Game.GetPlayer().SetGhost(true)
		Game.DisablePlayerControls(abMovement = true, abFighting = true, abCamSwitch = true, abLooking = false, abSneaking = true, abMenu = true, abActivate = true, abJournalTabs = true)
;		Game.GetPlayer().RestoreActorValue("health", 9999)

		if (NecroLichRitualQuest as NecroLichTrackingQuest).Shroud == 1 && (NecroLichRitualQuest as NecroLichTrackingQuest).Flesh == 1
				;transform the player into the red flesh lich
				Game.GetPlayer().UnequipItem(NecroLichSkin01,  False, True)
		elseif (NecroLichRitualQuest as NecroLichTrackingQuest).Shroud == 1 && (NecroLichRitualQuest as NecroLichTrackingQuest).Flesh == 0
				;transform the player into the red skeletal lich
				Game.GetPlayer().UnequipItem(NecroLichSkin05,  False, True)
		elseif (NecroLichRitualQuest as NecroLichTrackingQuest).Shroud == 2 && (NecroLichRitualQuest as NecroLichTrackingQuest).Flesh == 1
				;transform the player into the green flesh lich
				Game.GetPlayer().UnequipItem(NecroLichSkin02,  False, True)
		elseif (NecroLichRitualQuest as NecroLichTrackingQuest).Shroud == 2 && (NecroLichRitualQuest as NecroLichTrackingQuest).Flesh == 0
				;transform the player into the green skeletal lich
				Game.GetPlayer().UnequipItem(NecroLichSkin06,  False, True)
		elseif (NecroLichRitualQuest as NecroLichTrackingQuest).Shroud == 3 && (NecroLichRitualQuest as NecroLichTrackingQuest).Flesh == 1
				;transform the player into the black flesh lich
				Game.GetPlayer().UnequipItem(NecroLichSkin09,  False, True)
				Game.GetPlayer().UnequipItem(NecroLichSkin09,  False, True)
		elseif (NecroLichRitualQuest as NecroLichTrackingQuest).Shroud == 3 && (NecroLichRitualQuest as NecroLichTrackingQuest).Flesh == 0
				;transform the player into the black skeletal lich
				Game.GetPlayer().UnequipItem(NecroLichSkin11,  False, True)
		endif

;		DLC1VampMistFormFX.Play(Game.GetPlayer(),30)
		Game.GetPlayer().placeAtMe(FXDragonPriestLargeExplosion, 1)
		NecroPhylacteryEtherealizeSpell.Cast(Game.GetPlayer(), Game.GetPlayer())
		Game.GetPlayer().GetActorBase().SetInvulnerable(true)
		Game.GetPlayer().SetGhost(true)
		Game.GetPlayer().EquipItem(SkinSkeletonNecroPriest, False, True)
		;Game.GetPlayer().RestoreActorValue("Health", (Game.GetPlayer().GetBaseActorValue("health") * 30) / 100)
;		Game.GetPlayer().ForceActorValue("Health", 30)
		Game.GetPlayer().pushActorAway(Game.GetPlayer(), 50)
;		utility.Wait(1.0)
;		(NecroTrackingQuest as NecroTrackingQuestSCRIPT).PlayerAlias.Clear()

;		debug.notification("Player should have changed")
		NecroPerkPhylacteryRegenTimer.SetValue(GameDaysPassed.GetValue() + 0.0)
; ;		debug.trace(self + " Heal "+ PerkAvoidDeathTimer.GetValue() + " " + GameDaysPassed.GetValue())
; 		debug.trace(self + " PlayerAlias=" + PlayerAlias.GetRef())
		utility.wait(5.0)

		TransitionFX.play(Game.GetPlayer())
		DLC2ApocryphaRewardBookEnter.Apply()
		utility.wait(1.5)
		DLC2ApocryphaRewardBookEnter.PopTo(FadeToBlackHoldImod)
		; move player home
		(NecroTrackingQuest as NecroTrackingQuestSCRIPT).MovePlayerHome(true)
;		Game.GetPlayer().UnequipItem(SkinSkeletonNecroPriest, False, True)
;		NecroLichTransformPlayerFireFXShort.Play(Game.GetPlayer(),0.5)

;		FXfallingSandDragonPriestEffect.Stop(Game.GetPlayer())
		TransitionFX.stop(Game.GetPlayer())
		Game.GetPlayer().GetActorBase().SetInvulnerable(false)
		Game.GetPlayer().SetGhost(false)
;		(NecroTrackingQuest as NecroTrackingQuestSCRIPT).PlayerAlias.Clear()
		bInBleedout = false
	Endif
	If (Game.GetPlayer().HasPerk(NecroPhylacteryRegenPerk) == 1) && (Game.GetPlayer().GetRace() != LichRace)
		; Let the player 'die' in bleedout and then teleport them to the phylactery
		;Game.GetPlayer().SetGhost(true)
;		NecroPerkPhylacteryRegenTimer.SetValue(GameDaysPassed.GetValue() + 0.0)
;		Game.GetPlayer().GetActorBase().SetInvulnerable(true)
;		Game.GetPlayer().SetGhost(true)
        Game.DisablePlayerControls(abMovement = true, abFighting = true, abCamSwitch = true, abLooking = false, abSneaking = true, abMenu = true, abActivate = true, abJournalTabs = true)

;		DLC1VampMistFormFX.Play(Game.GetPlayer(),30)
		Game.GetPlayer().placeAtMe(FXDragonPriestLargeExplosion, 1)
        NecroPhylacteryEtherealizeSpell.Cast(Game.GetPlayer(), Game.GetPlayer())
		Game.GetPlayer().GetActorBase().SetInvulnerable(true)
		Game.GetPlayer().SetGhost(true)
;		DLC1VampireChangeStagger.Cast(Game.GetPlayer())
		;Game.GetPlayer().RestoreActorValue("Health", (Game.GetPlayer().GetBaseActorValue("health") * 30) / 100)
;		Game.GetPlayer().ForceActorValue("Health", 30)
		;Game.GetPlayer().pushActorAway(Game.GetPlayer(), 1)
;		utility.wait(1.0)
;		(NecroTrackingQuest as NecroTrackingQuestSCRIPT).PlayerAlias.Clear()
;		debug.notification("Player should have changed")

		NecroPerkPhylacteryRegenTimer.SetValue(GameDaysPassed.GetValue() + 0.0)
; ;		debug.trace(self + " Heal "+ PerkAvoidDeathTimer.GetValue() + " " + GameDaysPassed.GetValue())
; 		debug.trace(self + " PlayerAlias=" + PlayerAlias.GetRef())
		utility.wait(5.0)

;		NecroPerkPhylacteryRegenTimer.SetValue(GameDaysPassed.GetValue() + 0.0)
		TransitionFX.play(Game.GetPlayer())
		DLC2ApocryphaRewardBookEnter.Apply()
		utility.wait(1.5)
		DLC2ApocryphaRewardBookEnter.PopTo(FadeToBlackHoldImod)
		; move player home
		MovePlayerHome(true)
;		Game.GetPlayer().UnequipItem(SkinSkeletonNecroPriest, False, True)
;		NecroLichTransformPlayerFireFXShort.Play(Game.GetPlayer(),0.5)

;		FXfallingSandDragonPriestEffect.Stop(Game.GetPlayer())
		TransitionFX.stop(Game.GetPlayer())
		Game.GetPlayer().GetActorBase().SetInvulnerable(false)
		Game.GetPlayer().SetGhost(false)
;		(NecroTrackingQuest as NecroTrackingQuestSCRIPT).PlayerAlias.Clear()
		Game.GetPlayer().equipspell(LichTransform, 2)
		bInBleedout = false
	endif	

endFunction

Quest Property NecroLichRitualQuest auto

ObjectReference Property NecroLichRitualXMarkerHeading001 auto
ObjectReference Property NecroLichRitualXMarkerHeading002 auto

ObjectReference Property NecroLichTransformationRitualTarget01 auto
ObjectReference Property NecroLichTransformationRitualTarget02 auto
ObjectReference Property NecroLichTransformationPhylacteryFX001 auto
ObjectReference Property NecroLichTransformationPhylacteryFX002 auto

ReferenceAlias Property PlayerAlias auto

ImageSpaceModifier Property FadeToBlackHoldImod  Auto  

ImageSpaceModifier Property DLC2ApocryphaRewardBookEnter  Auto  
ImageSpaceModifier Property DLC2ApocryphaRewardBookExit  Auto  

VisualEffect Property FxfallingSandDragonPriestEffect auto

EffectShader Property NecroLichTransformPlayerFireFXShort auto

Armor Property SkinSkeletonNecroPriest auto 
Armor Property NecroLichSkin01 auto
Armor Property NecroLichSkin02 auto
Armor Property NecroLichSkin03 auto
Armor Property NecroLichSkin04 auto
Armor Property NecroLichSkin05 auto
Armor Property NecroLichSkin06 auto
Armor Property NecroLichSkin07 auto
Armor Property NecroLichSkin08 auto
Armor Property NecroLichSkin09 auto
Armor Property NecroLichSkin10 auto
Armor Property NecroLichSkin11 auto

Keyword Property ActorTypeUndead  Auto  

Keyword Property ActorTypeLich  Auto  

GlobalVariable Property GameHour  Auto  

float Property PercentHealth = 100.0 Auto  

Quest Property NecroTrackingQuest Auto

bool bInBleedout

Explosion Property FXDragonPriestLargeExplosion auto

EffectShader Property DLC1VampMistFormFX auto
EffectShader Property TransitionFX auto
Effectshader Property Transition02FX auto

Spell Property NecroPhylacteryEtherealizeSpell auto
Spell Property NecroPerkPhylacteryRegenAbility auto
Spell Property LichTransform auto
Spell Property NecroRevert auto
Spell Property NecroDeathGrip auto
Spell Property NecroLichIncinerate auto

Perk Property NecroPhylacteryRegenPerk auto

Race Property LichRace auto

ReferenceAlias Property KeywordAlias  Auto  

Perk Property NecroMagicalAptitude Auto